sys/dev/disk/dm: Add info() handler for striped target for compatibility
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
16 -------------------------------------------------
17
18 The est(4) driver has been removed. All CPUs it supported (except one)
19 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
20 report back if there are any issues with this CPU and our regular ACPI
21 P-state support.
22
23 Also, compile_et(1) and com_err(3) have been removed as well. They
24 should have been removed along with kerberos support, back in 2009.
25
26 SEVERAL LOCALES RENAMED
27 -----------------------
28
29 Several locales were using obsolete and misleading names, and thus have
30 been adjusted to current standards. Any users of the following locales
31 need to select alternates:
32
33 DFLY 4.2 locale            DFLY 4.4 alterative locale
34 ---------------            ------------------------------------
35 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
36 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
37 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
38 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
39 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
40 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
41 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
42 zh_CN.GBK                  zh_Hans_CN.GBK
43 zh_CN.UTF-8                zh_Hans_CN.UTF-8
44 zh_CN.eucCN                zh_Hans_CN.eucCN
45 zh_CN.GB2312               zh_Hans_CH.GB2312
46 zh_CN.GB18030              zh_Hans_CH.GB18030
47 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
48 zh_HK.UTF_8                zh_Hant_HK.UTF-8
49 zh_TW.Big5                 zh_Hant_TW.Big5
50 zh_TW.UTF-8                zh_Hant_TW.UTF-8
51
52 +-----------------------------------------------------------------------+
53 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
54 +-----------------------------------------------------------------------+
55
56 BINUTILS 2.25 REPLACES 2.22, PRIMARY
57 ------------------------------------
58
59 The oldest of the two versions of Binutils, version 2.22, was removed
60 and replaced with Binutils 2.25.  It becomes the primary version version
61 of binutils and version 2.24 becomes the alternate.  There are 8 current
62 CVE written against 2.24, so for security reasons version 2.25 should
63 always be used.
64
65 The accepted values of BINUTILSVER are now "binutils225" (default) and
66 "binutils224".  The building of Binutils 2.24 can be prevented by setting
67 NO_ALTBINUTILS=yes in make.conf.
68
69 LOADER OPTIONS CHANGED
70 ----------------------
71
72 Right after the development branch started, the Fred art accompanying the
73 loader menu was improved.  The line between Fred and the menu was removed
74 by default (but can optionally be returned) and the placement shifted as
75 a result.  The drawing was improved, and the colored version was improved,
76 changing the eyes and wing color from white to red.  A new color version
77 of Fred was added, one with a blue scheme.
78
79 The loader menu defaults have changed since release 4.0:  The vertical
80 line was removed, the loader is displayed in color by default*, and the
81 blue scheme is used.
82
83 The loader.conf changes are:
84 loader_color:   option has been removed
85 loader_plain:   option has been added, it changed menu to monochrome
86 fred_is_red:    changes color scheme from blue to red
87 fred_is_blue:   option existed only on 4.1, it has been removed
88 fred_separated: Adds line between Fred and menu (as seen previously)
89
90 * If loader.conf defines "console" as "comconsole" or "console" is defined
91   in the environment as "comconsole" then color will not be displayed,
92   even if loader_plain value is "NO".
93
94 SENDMAIL REMOVED FROM BASE
95 --------------------------
96
97 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
98 If the system being upgraded is still configured to use the sendmail
99 binaries from base, the "make upgrade" command will fail.
100
101 The administrator must change /etc/mail/mailer.conf to switch the
102 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
103 command that permanently removes sendmail executables and could
104 potentially break a running mail server.
105
106 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
107 detailed instructions on how to configure the MTA selection.
108
109 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
110 --------------------------------------------
111
112 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
113 no-ops. They can be removed from custom kernel configurations.
114
115 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
116 --------------------------------------------
117
118 Many more sound devices may be detected.
119
120 If the default device choosen isn't to your liking, setting the sysctl
121 hw.snd.default_unit to a different number will change it.
122
123 SCTP SUPPORT DROPPED
124 --------------------
125
126 Support for the SCTP protocol has been removed.
127
128 OLD USB DRIVERS REMOVED
129 -----------------------
130
131 The old USB stack, along with the kernel config option "device oldusb"
132 and the make.conf variable "WANT_OLDUSB" have been removed. This means
133 that for custom kernel configuration files which were derived from a
134 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
135 various (old USB stack specific) devices will now complain about being
136 unknown:
137
138   * oldusb      (obviously)
139   * natausb     (not yet ported to usb4bsd)
140   * rue         (not yet ported to usb4bsd)
141   * ugen        (no longer needed in usb4bsd)
142   * urio        (not yet ported to usb4bsd)
143   * uscanner    (no longer needed in usb4bsd)
144
145 They should be removed or commented out in such custom kernel configs.
146
147 GCC 5
148 -----
149
150 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
151 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
152 NO_CXX.  The latter was never documented and the latest versions of GCC are
153 partially written in C++ so a C++ compiler is no longer optional.  In
154 practical terms it has not been optional for many years as other base
155 components are also written in C++.  The resource savings by avoiding
156 building Objective-C compiler is so small, the complexity added by NO_OBJC
157 internally was deemed a bad tradeoff so that is the reason for its removal.
158 Also note that no "info" pages are installed with GCC 5.  After this entry
159 was originally written, all info pages were removed from DragonFly.
160
161 GCC 5.1 has been designated as the primary compiler.  As such, there is a
162 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
163 the designated secondary compiler, GCC 4.7.  However, while DPorts
164 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
165 if building ports from source is desired, don't block building of the
166 secondary compiler.
167
168 +-----------------------------------------------------------------------+
169 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
170 +-----------------------------------------------------------------------+
171
172 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
173 -------------------------------------------
174
175 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
176 the default now (even on single-core systems), both for, like, 21 months.
177 We kept the options around as no-ops as a convenience, to allow people
178 using the same config for the then current release and the then current
179 master. That period is now over, so any configs still having those
180 options have to be adjusted.
181
182 SYSVIPC SYSCALLS MADE NON-OPTIONAL
183 ----------------------------------
184
185 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
186 now compiled in by default. The options are no-ops for now.
187
188 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
189 --------------------------------------------------------------------
190
191 The default driver for those controllers is now mrsas(4) due to reports
192 of file system corruption using the mfi(4) driver. The whole issue (and
193 how to deal with potential problems when switching) was explained here:
194
195 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
196
197 A tunable is provided for letting those controllers still attach via
198 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
199
200 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
201 ----------------------------------------
202
203 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
204 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
205 removed in kernel configs derived from X86_64_GENERIC.
206
207 +-----------------------------------------------------------------------+
208 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
209 +-----------------------------------------------------------------------+
210
211 UPDATE FROM MOST RECENT 3.6
212 ---------------------------
213
214 Versions of 3.6 built before June 25th have a bug where installworld might 
215 crash during installation of the new initrd.  Upgrade to the latest version
216 of 3.6 before updating to 3.8 or later.
217
218 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
219 --------------------------------------
220
221 Support for the IPX and NCP network protocols and for mouting NetWare
222 file systems has been dropped. Dito for ATM protocol support.
223
224 INITRD IMAGES NOW INSTALLED BY DEFAULT
225 --------------------------------------
226
227 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
228
229 Older images installed under the file name of initrd.img will be removed
230 automatically by the make upgrade process.
231
232 USB4BSD IS NOW THE DEFAULT USB STACK
233 ------------------------------------
234
235 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
236 replace "device usb" with "device oldusb" in the kernel configuration.
237
238 MORE ISA SUPPORT DROPPED
239 ------------------------
240
241 ISA support has been dropped from the following drivers: adv(4), an(4),
242 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
243 si(4), sn(4), and stg(4).
244
245 +-----------------------------------------------------------------------+
246 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
247 +-----------------------------------------------------------------------+
248
249 ABI CHANGE
250 ----------
251
252 Installed third-party software (dports) will have to be rebuilt after upgrade,
253 or reinstalled from binary packages.
254
255 UPDATING FROM 3.4 TO 3.6
256 ------------------------
257
258 This only applies for this specific upgrade due to locale changes; it is 
259 not needed for upgrades after 3.6.  Please update in this order:
260
261 make buildworld
262 make buildkernel
263 make installworld
264 make installkernel
265 *reboot*
266 make upgrade
267
268 See this mailing list post for details:
269 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
270
271 CYRIX OPTIONS REMOVED
272 ---------------------
273
274 The following Cyrix related options have been removed: CPU_BTB_EN,
275 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
276 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
277 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
278
279 ISA SUPPORT REMOVED FROM RP(4)
280 ------------------------------
281
282 ISA support has been removed from the rp(4) driver. It is now PCI only.
283
284 +-----------------------------------------------------------------------+
285 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
286 +-----------------------------------------------------------------------+
287
288 COMPAT_SUNOS OPTION REMOVED
289 ---------------------------
290
291 The COMPAT_SUNOS option has been removed. It was meant to provide binary
292 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
293
294 ISA SOUND CARD SUPPORT REMOVED
295 ------------------------------
296
297 The following modules have been removed (all for ISA sound cards):
298 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
299
300 GCC 4.7
301 -------
302
303 DragonFly has switched base compilers.  GCC 4.7 is now the default
304 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
305 variable ceases to work now.
306
307 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
308 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
309 highly discouraged.  There are a few packages in pkgsrc that do not build
310 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
311 this time, it is recommended to keep both compilers on the base system.
312
313 SMP OPTION REMOVED
314 ------------------
315
316 The SMP kernel option has been made a no-op. All kernels now feature SMP
317 support. If you have 'options SMP' in your kernel config, you can as well
318 remove it.
319
320 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
321 ---------------------------------------------------------------------------
322
323 The DEVICE_POLLING kernel option has been made a no-op and it has been
324 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
325 kernel config, you need to change it to IFPOLL_ENABLE.
326
327 Also, the KTR_POLLING kernel option has been removed, so it must be
328 removed from kernel configs that have it.
329
330 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
331 ---------------------------------------------------
332
333 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
334 cards will no longer be detected.
335
336 The same has been done for Stallion multiport serial controllers. stli(4)
337 has been completely removed (along with the stlload(8) and stlstty(8)
338 utilities) and stl(4) was changed to support only PCI cards. Similarly,
339 ISA support was removed from cy(4) too. All these drivers are i386 only.
340
341 COMPAT_OLDISA OPTION GONE
342 -------------------------
343
344 The i386 specific COMPAT_OLDISA kernel option has been removed, since
345 nothing needs it anymore.
346
347 +-----------------------------------------------------------------------+
348 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
349 +-----------------------------------------------------------------------+
350
351 APIC_IO OPTION REMOVED
352 ----------------------
353
354 The APIC_IO kernel option is no longer accepted after having been without
355 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
356 If you have 'options APIC_IO' in your kernel config, you'll have to
357 remove it.
358
359 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
360 -----------------------------------------
361
362 The wdog framework is now compiled into our kernels by default, so the
363 options are no longer needed.
364
365 DOSCMD(1) REMOVED
366 -----------------
367
368 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
369 NO_X make.conf option was removed too.
370
371 GCC 4.7
372 -------
373
374 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
375 default compiler in base (default is still GCC 4.4).
376
377 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
378 NO_GCC47 in /etc/make.conf.
379
380 USB4BSD
381 -------
382
383 A new USB stack (from FreeBSD) has been brought in. The following
384 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
385 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
386 and uaudio.
387
388 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
389 be put in make.conf and device "usb4bsd" (quotes needed) has to
390 replace device usb in the kernel config. After that, a full
391 build/install/upgrade cycle is needed.
392
393 Note that this is experimental and incomplete, but we are interested
394 in hearing about issues with it, of course.
395
396 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
397 ---------------------------------------------
398
399 ISA adapter support was dropped from the aic(4) driver.
400
401 +-----------------------------------------------------------------------+
402 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
403 +-----------------------------------------------------------------------+
404
405 SEVERAL ISA DRIVERS REMOVED
406 ---------------------------
407
408 The following ISA only drivers have been removed along with a couple of
409 associated userland tools:
410
411 aha(4)
412 asc(4) & sasc(1)
413 ctx
414 dgb(4)
415 el(4)
416 gpib
417 gsc(4) & sgsc(1)
418 ie(4)
419 labpc(4)
420 le(4)
421 mse(4)
422 rc(4)
423 rdp(4)
424 spigot
425 tw(4) & xten(1) & xtend(8)
426 wl(4) & wlconfig(8)
427 wt(4)
428
429 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
430 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
431 file.
432
433 If buildkernel complains about any of these drivers, just remove them
434 from your kernel configuration.
435
436 BINUTILS 2.20
437 -------------
438 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
439 values of BINUTILSVERS are now binutils221 and binutils222 (default).
440
441 BUILDWORLD/-KERNEL PARALLELIZATION WORK
442 ---------------------------------------
443 Due to changes in the way we build with more than one make job, you
444 will have to update install(1) and mkdir(1) prior to buildworld if you
445 want to build with 'make -j':
446
447 cd /usr/src/usr.bin/xinstall; make; make install; make clean
448 cd /usr/src/bin/mkdir; make; make install; make clean
449
450 DMA(8) UPGRADE
451 --------------
452 dma(8) has been upgraded to v0.7 which no longer supports the
453 /etc/dma/virtusertable. Some of its functionality has been replaced
454 with the MASQUERADE keyword and the EMAIL environment variable (see
455 the dma(8) manual page).
456
457 +-----------------------------------------------------------------------+
458 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
459 +-----------------------------------------------------------------------+
460
461 GCC 4.4 & BINUTILS 2.21
462 -----------------------
463
464 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
465 been made DragonFly's default Binutils.
466
467 That means that any settings that set CCVER to 'gcc44' are not needed
468 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
469 GCC 4.1.
470
471 It also means that 'binutils221' as a value for BINUTILSVER has no
472 effect anymore. 2.17 has been removed and 'binutils220' is available
473 as an option.
474
475 The NO_GCC44 option has been removed and will not affect the build
476 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
477 building in a similar fashion.
478
479 Note that you must do a full buildworld/buildkernel for upgrading.
480
481 pkg_radd settings
482 -----------------
483
484 The config file for pkg_radd has moved from /etc/settings.conf to 
485 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
486 if this is needed.  This warning only applies if /etc/settings.conf 
487 exists.  pkg_radd will continue to work with defaults.
488
489 +-----------------------------------------------------------------------+
490 +         20100927                                                      +
491 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
492 +-----------------------------------------------------------------------+
493
494 OpenSSL
495 --------
496
497 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
498 This shouldn't break any 3rd-party software, but you'll need to recompile your
499 3rd-party software if you want it to link against the new version of OpenSSL.
500
501 Loader
502 -------
503
504 A new loader (dloader) has been added which better handles booting from
505 multiple kernel/module versions.
506
507 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
508
509         cd /usr/src
510         make buildworld
511         make installworld
512         make upgrade
513         make buildkernel KERNCONF=<KERNELNAME>
514         make installkernel KERNCONF=<KERNELNAME>
515
516 Note that you must installworld and run the 'upgrade' target before
517 installing the new kernel.
518
519 BIND
520 -----
521
522 BIND has been removed from the base system.  The ldns and drill tools have 
523 been added for basic functionality.  Use 'drill' where you would normally 
524 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
525 net/bind95, net/bind96, or net/bind97 as of this writing.
526
527 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
528 include BIND as a pkgsrc package.
529
530 +-----------------------------------------------------------------------+
531 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
532 +                               GENERAL                                 +
533 +-----------------------------------------------------------------------+
534
535 Instructions on how to obtain and maintain DragonFly source code using git
536 are in the development(7) manual page.
537
538 To upgrade a DragonFly system from sources you run the following sequence:
539
540         cd /usr/src
541         make buildworld
542         make buildkernel KERNCONF=<KERNELNAME>
543         make installkernel KERNCONF=<KERNELNAME>
544         make installworld
545
546 You will also want to run the 'upgrade' target to upgrade your /etc and the
547 rest of your system.  The upgrade target is aware of stale files created by
548 older DragonFly installations and should delete them automatically.
549
550         make upgrade
551
552 See the build(7) manual page for further information.
553
554 Once you've done a full build of the world and kernel you can do incremental
555 upgrades of either by using the 'quickworld' and 'quickkernel' targets
556 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
557 the quick targets, try updating your repo first, and then a full buildworld
558 and buildkernel as shown above, before asking for help.
559
560 +-----------------------------------------------------------------------+
561 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
562 +-----------------------------------------------------------------------+
563
564 In 2.1 kernel and modules has moved to boot directory.  For most cases
565 this is handled automatically by 'make upgrade'.  A few cases needs manual
566 intervention:
567
568  * When installing a kernel without first doing a make buildworld,
569    installworld and upgrade to the same DESTDIR as kernel:
570    make DESTDIR/boot directory and move kernel and modules into this boot
571    directory; also move kernel.old and modules.old.
572    Typical example is vkernel(7), use (no modules used):
573
574         cd /var/vkernel
575         mkdir boot
576         chflags noschg kernel
577         mv kernel kernel.old boot
578         chflags schg boot/kernel
579         
580  * When using a boot-only partition, /boot/loader.rc needs to be edited:
581    delete occurrences of '/boot/'.
582    These occurences can normally be deleted in any case, see loader(8).
583
584 +-----------------------------------------------------------------------+
585 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
586 +-----------------------------------------------------------------------+
587
588 In 1.9 major changes to the disk management infrastructure have taken
589 place.  make upgrade may not catch all of your disk devices in /dev,
590 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
591 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
592 and MAKEDEV no longer exists.
593
594 The biggest changes in 1.9 are:
595
596 (1) That whole-slice devices such as da0s1 no longer share the same device
597     id as partition c devices such as da0s1c.
598
599 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
600     with no snooping or reserved sectors.  Consequently you cannot run
601     disklabel on this device.  Instead you must run disklabel on a
602     whole-slice device.
603
604 (3) The 'compatibility' partitions now use slice 0 in the device name,
605     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
606     accessing the disklabel for the compatibility partitions must be
607     done via slice 0 (da0s0).
608
609 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
610     and CCD now run through the disk management layer and are assigned
611     real disk management devices.   VN and CCD in particular do not usually
612     use a MBR and disklabels must be accessed through the compatibility
613     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
614     don't name it 'ccd0s0' in the config file.
615
616 Generally speaking, you have to get used to running fdisk and disklabel on
617 the correctly specified device names.  A lot of the wiggle, such as running
618 disklabel on a partition, has been removed.
619
620 +-----------------------------------------------------------------------+
621 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
622 +-----------------------------------------------------------------------+
623
624 > Kerberos IV
625 -------------
626
627 Kerberos IV (eBones) was removed from the tree, please consider moving to
628 Kerberos 5 (Heimdal).
629
630 > Package Management System
631 ---------------------------
632
633 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
634 management system.  The necessary tools to build and maintain packages
635 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
636 directories are in your PATH variable.
637
638 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
639 the tarball from NetBSD:
640
641         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
642         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
643
644 This tree can then be kept up to date with cvs update:
645
646         cd /usr/pkgsrc; cvs up
647
648 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
649 build and install the pkgsrc bootstrap manually:
650
651         cd /usr/pkgsrc/bootstrap
652         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
653
654 +-----------------------------------------------------------------------+
655 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
656 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
657 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
658 +-----------------------------------------------------------------------+
659
660 The compatibility shims for the build environment have been removed, you
661 have to update to DragonFly 1.2 release branch first.
662
663 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
664 The existing configuration can be converted using /etc/pam.d/convert.sh.
665 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
666 the pam_skey.so module was retired, you have to remove it manually from
667 your configuration, when you convert it.
668
669 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
670 ---------------------
671
672 The following users may be missing from your password file.  Use vipw and
673 add any that are missing:
674
675 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
676 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
677
678 The following groups may be missing from your group file.  Use vi /etc/group
679 and add any that are missing:
680
681 smmsp:*:25:
682 authpf:*:63:
683 _pflogd:*:64:
684
685
686 > Upgrading to DragonFly from FreeBSD
687 ---------------------
688
689 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
690 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
691 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
692 make depend information, it starts from scratch, so no pre-cleaning of the
693 object hierarchy is necessary.
694
695         # get the CVS repository (it is placed in /home/dcvs, 500MB).
696         # Please use the -h option and a mirror site to pull the 
697         # initial repository, but feel free to use the main repository
698         # machine to pull updates.
699         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
700         # install the source from the CVS hierarchy (remove preexisting
701         # FreeBSD src first) (500MB)
702         cd /usr
703         rm -rf src
704         cvs -R -d /home/dcvs checkout -P src
705
706         # build it (500MB used in /usr/obj)
707         #
708         cd /usr/src
709         make buildworld
710         make buildkernel KERNCONF=<KERNELNAME>
711
712 Once you have built DragonFly you have to install it over FreeBSD.  Since
713 DragonFly does not track changes made by FreeBSD to its include file 
714 hierarchy and include file pollution can cause all sorts of unexpected
715 compilation issues to come up, it is best to wipe your include hierarchy
716 prior to installing DragonFly.  Note that you should not wipe any installed
717 FreeBSD header files or binaries until after you have successfully completed
718 the build steps above.
719
720         rm -rf /usr/include
721         mkdir /usr/include
722         make installkernel KERNCONF=<KERNELNAME>
723         make installworld
724
725 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
726 will unconditionally upgrade the /etc files that sysops do not usually
727 mess around with, such as the files in /etc/rc.d.  It will also remove any
728 obsolete files such as utilities and manpages that have been removed from
729 the system since the version you're coming from.  If you are unsure we 
730 recommend that you make a backup of at least your /etc before applying
731 this step.  Note that DragonFly's RC system is basically RCNG from
732 FreeBSD-5, but there are some differences in the contents of the RC files.
733
734         make upgrade
735
736 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
737 Doing so might leave your system in an unusable state.
738
739 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
740 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
741 report these files to the DragonFly developers so that they can be added to
742 the 'upgrade' target.
743